package com.foxconn.flownet.controller;

package ..deTemp.1733721875056;

import com.foxconn.api.R;
import com.foxconn.flownet.entity.pdm.DocInfo;
import com.foxconn.flownet.entity.pdm.Library;
import com.foxconn.flownet.entity.pdm.SystemAccount;
import com.foxconn.flownet.entity.pdm.SystemRoleAccount;
import com.foxconn.flownet.entity.project.ProjectT;
import com.foxconn.flownet.form.MongoForm;
import com.foxconn.flownet.service.CommonService;
import com.foxconn.flownet.util.IPUtil;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping({"/donet"})
public class CommonController {
  private static final Logger log = LoggerFactory.getLogger(com.foxconn.flownet.controller.CommonController.class);
  
  @Autowired
  CommonService commonService;
  
  @PostMapping({"/systemAccount"})
  public R systemAccount(HttpServletRequest request, @RequestBody SystemAccount systemAccount) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call systemAccount");
    return R.ok(this.commonService.getSystemAccount(systemAccount));
  }
  
  @PostMapping({"/systemRoleAccount"})
  public R systemRoleAccount(HttpServletRequest request, @RequestBody SystemRoleAccount systemRoleAccount) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call systemRoleAccount");
    return R.ok(this.commonService.getSystemRoleAccount(systemRoleAccount));
  }
  
  @PostMapping({"/getLibraryByName"})
  public R checkLibName(HttpServletRequest request, @RequestBody Library library) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call getLibraryByName");
    return R.ok(this.commonService.getLibraryByName(library.getLibName()));
  }
  
  @PostMapping({"/getLibTemplates"})
  public R getLibTemplates(HttpServletRequest request, @RequestBody Library library) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call getLibTemplates");
    return R.ok(this.commonService.getLibTemplates(library.getType()));
  }
  
  @PostMapping({"/getDocInfoTbl"})
  public R getDocInfoTbl(HttpServletRequest request, @RequestBody DocInfo docInfo) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call getDocInfoTbl");
    List<DocInfo> docInfoList = this.commonService.getDocumentInfo(docInfo);
    return R.ok(docInfoList);
  }
  
  @PostMapping({"/getDProjectT"})
  public R getDProjectT(HttpServletRequest request, @RequestBody ProjectT projectT) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call getDProjectT");
    return R.ok(this.commonService.getDProjectT(projectT));
  }
  
  @PostMapping({"/getEssnProjectT"})
  public R getEssnProjectT(HttpServletRequest request, @RequestBody Map<String, String> params) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call getEssnProjectT");
    String PROJECTNAME = params.get("PROJECTNAME");
    return R.ok(this.commonService.getEssnProjectT(PROJECTNAME));
  }
  
  @PostMapping({"/getPersonInfo"})
  public R getPersonInfo(HttpServletRequest request, @RequestBody Map<String, String> params) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call getPersonInfo");
    String projectName = params.get("projectName");
    MongoForm result = this.commonService.getMongoData(projectName);
    return R.ok(result);
  }
  
  @PostMapping({"/pdmLibCallback"})
  public R pdmLibCallback(HttpServletRequest request, @RequestBody String json) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call pdmLibCallback");
    log.info(json);
    String result = this.commonService.flownetCallBack(json);
    if (null == result)
      return R.ok(); 
    return R.error(result);
  }
  
  @PostMapping({"/edcDocCallback"})
  public R edcDocCallback(HttpServletRequest request, @RequestBody String json) {
    String ip = IPUtil.getIpAddrByRequest(request);
    log.info(ip + "==> call edcDocCallback");
    log.info(json);
    String result = this.commonService.flownetCallBack(json);
    if (null == result)
      return R.ok(); 
    return R.error(result);
  }
}
